<?php

declare(strict_types=1);

namespace PrestaShop\Module\GdprCookieConsent\Controller;

use PrestaShopBundle\Controller\Admin\FrameworkBundleAdminController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class GdprConfigurationController extends FrameworkBundleAdminController
{
    /**
     * @param Request $request
     * @return Response
     */
    public function indexAction(Request $request): Response
    {
        $formDataHandler = $this->get('prestashop.module.gdprcookieconsent.form.gdpr_configuration_form_data_handler');

        $form = $formDataHandler->getForm();
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $errors = $formDataHandler->save($form->getData());

            if (empty($errors)) {
                $this->addFlash('success', $this->trans('Successful update.', 'Admin.Notifications.Success'));

                return $this->redirectToRoute('gdpr_cookie_consent_configuration');
            }

            $this->flashErrors($errors);
        }

        return $this->render('@Modules/gdprcookieconsent/views/templates/admin/configuration.html.twig', [
            'gdprConfigurationForm' => $form->createView(),
        ]);
    }
}