<?php

declare(strict_types=1);

namespace PrestaShop\Module\GdprCookieConsent\Form;

use PrestaShop\PrestaShop\Core\Configuration\DataConfigurationInterface;
use PrestaShop\PrestaShop\Core\Form\FormDataProviderInterface;

/**
 * Provider is responsible for providing form data
 */
class GdprConfigurationFormDataProvider implements FormDataProviderInterface
{
    /**
     * @var DataConfigurationInterface
     */
    private $gdprConfigurationDataConfiguration;

    public function __construct(DataConfigurationInterface $gdprConfigurationDataConfiguration)
    {
        $this->gdprConfigurationDataConfiguration = $gdprConfigurationDataConfiguration;
    }

    /**
     * @return array
     */
    public function getData(): array
    {
        return $this->gdprConfigurationDataConfiguration->getConfiguration();
    }

    /**
     * @param array $data
     * @return array
     */
    public function setData(array $data): array
    {
        return $this->gdprConfigurationDataConfiguration->updateConfiguration($data);
    }
}